#!/usr/bin/perl

sub val {
        my $ret = "none";
        my $str = $_[0];
        @temp   = split(/=/,$str);
        $ret    = $temp[1];

        return $ret;
}

sub wanif {
	my $ret   = "LAN";
	my $wanip = $_[0];
	@temp     = split(/\n/,$ipaddr);
	@wan      = grep(/$wanip/,@temp);
	if ($#wan == 0) {
		@temp2 = split(/\s+/,$wan[0]);
		$ret = $temp2[7];
		if ($wanip eq "127.0.0.1") {
			$ret = "lo";
		}
	}
	return $ret;
}

$conn_file = "/proc/net/ip_conntrack";

$src_ip = $ARGV[0];

$contrack = `cat $conn_file`;

$ipaddr   = `ip addr`;

@lines = split(/\n/,$contrack);

@lines = sort(@lines);

printf "proto %-21s   %-21s   %-22s   %-20s\n","     Source","  Destination","     Gateway","STATE";

foreach (@lines) {
        @col = split(/\s+/,$_);
        if ($col[0] eq "tcp") {
                if ($col[4] =~ /src=$src_ip/) {
                        if ($col[10] eq "[UNREPLIED]") {
                                $src   = val($col[4]);
                                $dst   = val($col[5]);
                                $sport = val($col[6]);
                                $dport = val($col[7]);
                                $wanip = val($col[12]);
                                $state = $col[3];
				$iface = wanif($wanip);
				$str1  = $src . ":" . $sport;
				$str2  = $dst . ":" . $dport;
				$str3  = $iface . ":" . $wanip;
				if (($iface ne "LAN") && ($iface ne "lo")) {
                                	printf "tcp   %-21s   %-21s   %-22s   %-20s\n",$str1,$str2,$str3,$state;
				}
                        }
                        else {
                                $src   = val($col[4]);
                                $dst   = val($col[5]);
                                $sport = val($col[6]);
                                $dport = val($col[7]);
                                $wanip = val($col[11]);
                                $state = $col[3];
				$iface = wanif($wanip);
				$str1  = $src . ":" . $sport;
				$str2  = $dst . ":" . $dport;
				$str3  = $iface . ":" . $wanip;
				if (($iface ne "LAN") && ($iface ne "lo")) {
                                	printf "tcp   %-21s   %-21s   %-22s   %-20s\n",$str1,$str2,$str3,$state;
				}
                        }
                }
        }
        if ($col[0] eq "udp") {
                if ($col[3] =~ /src=$src_ip/) {
                        if ($col[9] eq "[UNREPLIED]") {
                                $src   = val($col[3]);
                                $dst   = val($col[4]);
                                $sport = val($col[5]);
                                $dport = val($col[6]);
                                $wanip = val($col[11]);
				$state = "UNREPLIED";
				$iface = wanif($wanip);
                                $str1  = $src . ":" . $sport;
                                $str2  = $dst . ":" . $dport;
				$str3  = $iface . ":" . $wanip;
				if (($iface ne "LAN") && ($iface ne "lo")) {
                                	printf "udp   %-21s   %-21s   %-22s   %-20s\n",$str1,$str2,$str3,$state;
				}
                        }
                        else {
                                $src   = val($col[3]);
                                $dst   = val($col[4]);
                                $sport = val($col[5]);
                                $dport = val($col[6]);
                                $wanip = val($col[10]);
				$state = "ASSURED";
				$iface = wanif($wanip);
                                $str1  = $src . ":" . $sport;
                                $str2  = $dst . ":" . $dport;
				$str3  = $iface . ":" . $wanip;
				if (($iface ne "LAN") && ($iface ne "lo")) {
                                	printf "udp   %-21s   %-21s   %-22s   %-20s\n",$str1,$str2,$str3,$state;
				}
                        }
                }
        }
}


